/***************************************************************************
      actionobject.h  -  abstract base class for objects using actions
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__ACTIONOBJECT_H
#define INCLUDED__ACTIONOBJECT_H
 
// Abstract base class for objects that wish to use actions (see actionmanager.h/cpp)
class ActionObject {
  public:
    virtual void Execute(void) = 0;
};

#endif
