/***************************************************************************
                          customproperty.cpp  -  property base class
                             -------------------
    begin                : Fri May 2 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstring>
#include <cstdlib>

#include "customproperty.h"

using namespace std;

CustomProperty::CustomProperty(const char *name) {
  this->name = strdup(name);
  this->required = false;
}

CustomProperty::~CustomProperty(void) {
  free(name);
}

const char *CustomProperty::GetName(void) {
  return name;
}

bool CustomProperty::IsRequired(void) {
  return required;
}

void CustomProperty::SetRequired(bool required) {
  this->required = required;
}

bool CustomProperty::IsReadOnly(void) {
  return false;
}
