/***************************************************************************
  functionproperty.h  -  property object that uses getter/setter functions
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__FUNCTIONPROPERTY_H
#define INCLUDED__FUNCTIONPROPERTY_H

#include "customproperty.h"
#include "../plugintypes.h"

class FunctionProperty: public CustomProperty {
  public:
    FunctionProperty(const char *name, propertygetfn getter, propertysetfn setter);
    int SetValue(Variant value);
    Variant GetValue(void);
  private:
    propertygetfn getter;
    propertysetfn setter;
};

#endif
