/***************************************************************************
 initialisebase.h  -  abstract interface for classes that can be initialised
                             -------------------
    begin                : Mon Oct 6 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__INITIALISEBASE_H
#define INCLUDED__INITIALISEBASE_H

struct InitialiseBase {
  public:
    virtual int DoInitialise(void) = 0;
    virtual void DoUninitialise(void) = 0;
};

#endif
