/***************************************************************************
                          object.cpp  -  parent object class
                             -------------------
    begin                : Tue Sep 17 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cstring>
#include <cstdlib>

// FIXME remove
#include <iostream>

#include "object.h"

using namespace std;

Object::Object(void) {
  // Dummy constructor
  cerr << "WARNING: Object dummy constructor being called" << endl;
}

Object::Object(const char *name) {
  this->name = strdup(name);
  this->owner = NULL; // default value
}

Object::~Object(void) {
  free(name);
}

const char *Object::GetName(void) {
  return name;
}

const char *Object::GetType(void) {
  return type;
}

void Object::SetOwner(OwnerObject *owner) {
  this->owner = owner;
}

OwnerObject *Object::GetOwner(void) {
  return owner;
}

