/***************************************************************************
                          object.h  -  parent object class
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__OBJECT_H
#define INCLUDED__OBJECT_H

#include "ownerobject.h"

class Object {
  public:
    Object(void);
    Object(const char *name);
    virtual ~Object(void);
    const char *GetType(void);
    const char *GetName(void);
    OwnerObject *GetOwner(void);
    void SetOwner(OwnerObject *owner);
  protected:
    const char *type;
    char *name;
    OwnerObject *owner;
};

#endif
