/***************************************************************************
                scriptbase.h  -  base class for script objects
                             -------------------
    begin                : Mon Oct 6 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SCRIPTBASE_H
#define INCLUDED__SCRIPTBASE_H

#include "object.h"

class ScriptBase: public Object {
  public:
    ScriptBase(const char *name, const char *code);
    virtual ~ScriptBase(void);
    void SetLineOffset(int line);
    virtual int Run(void) = 0;
    void IncRef(void);
    bool DecRef(void);
  protected:
    char *code;
    int lineoffset;
    int refcount;
};

#endif
