/***************************************************************************
         scripteventhandler.h  -  event handler which runs a script
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SCRIPTEVENTHANDLER_H
#define INCLUDED__SCRIPTEVENTHANDLER_H

#include "eventhandler.h"
#include "scriptbase.h"

class ScriptEventHandler: public EventHandler {
  public:
    ScriptEventHandler(const char *name, Object *source, Object *sink, ScriptBase *eventscript);
    virtual ~ScriptEventHandler(void);
  protected:
    virtual int InternalFire(void);
  private:
    ScriptBase *eventscript;
};

#endif
