#!/bin/sh
flex -i -+ -oscript_flex.cpp script_flex.l
bison -d script_bison.ypp -o script_bison.cpp --defines=script_bison.h
echo
echo "The following files have been rebuilt:"
echo "  script_bison.cpp"
echo "  script_bison.h"
echo "  script_flex.cpp"
echo

# This mod isn't needed with newer version of flex, but
# what the heck, it does no harm.
sed 's/delete yy_state_buf;/delete [] yy_state_buf;/g' < script_flex.cpp > script_flex.cpp-new
mv script_flex.cpp script_flex.cpp-old
mv script_flex.cpp-new script_flex.cpp

mv script_bison.h script_bison.h-orig
(echo '#include "script_property.h"'; cat script_bison.h-orig) > script_bison.h
