/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     tECHO = 258,
     tEXECHIDE = 259,
     tEXECWAIT = 260,
     tEXECWAITCAPTURE = 261,
     tEXEC = 262,
     tLOAD = 263,
     tLOADPLUGIN = 264,
     tPAGE = 265,
     tQUIT = 266,
     tDELAY = 267,
     tSTRING = 268,
     tNUMBER = 269,
     tTRUE = 270,
     tFALSE = 271,
     tNULL = 272,
     tIDENT = 273,
     tPLUS = 274,
     tMINUS = 275,
     tMULTIPLY = 276,
     tDIVIDE = 277,
     tREMAINDER = 278,
     tPOWER = 279,
     tDOT = 280,
     tASSIGN = 281,
     tAND = 282,
     tOR = 283,
     tXOR = 284,
     tNOT = 285,
     tEQUAL = 286,
     tNOTEQUAL = 287,
     tLESS = 288,
     tGREATER = 289,
     tLESSEQUAL = 290,
     tGREATEREQUAL = 291,
     tCOMMENT = 292,
     tLBRACKET = 293,
     tRBRACKET = 294,
     tCOMMA = 295
   };
#endif
#define tECHO 258
#define tEXECHIDE 259
#define tEXECWAIT 260
#define tEXECWAITCAPTURE 261
#define tEXEC 262
#define tLOAD 263
#define tLOADPLUGIN 264
#define tPAGE 265
#define tQUIT 266
#define tDELAY 267
#define tSTRING 268
#define tNUMBER 269
#define tTRUE 270
#define tFALSE 271
#define tNULL 272
#define tIDENT 273
#define tPLUS 274
#define tMINUS 275
#define tMULTIPLY 276
#define tDIVIDE 277
#define tREMAINDER 278
#define tPOWER 279
#define tDOT 280
#define tASSIGN 281
#define tAND 282
#define tOR 283
#define tXOR 284
#define tNOT 285
#define tEQUAL 286
#define tNOTEQUAL 287
#define tLESS 288
#define tGREATER 289
#define tLESSEQUAL 290
#define tGREATEREQUAL 291
#define tCOMMENT 292
#define tLBRACKET 293
#define tRBRACKET 294
#define tCOMMA 295




/* Copy the first part of user declarations.  */
#line 18 "script_bison.ypp"


#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm
#define YYERROR_VERBOSE

#include <cstring>
#include <cmath>
#include <string>
#include <cstdlib>
#include <iostream>
#include <map>

#include "script.h"
#include "pluginmanager.h"
#include "basewidgets/utils.h"
#include "basewidgets/variant.h"
#include "main.h"

extern int yylex(void);
extern void yyerror(char *msg);
extern FILE *yyin;
extern int yylineno;

extern char string_buf[MAX_STR_CONST];

// Function prototypes
extern PluginManager plugin_manager;
Variant callMethodArgs(const char *object, const char *method, vector<Variant> *args);

// Global variables
std::map<std::string,Variant> vartable;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 53 "script_bison.ypp"
typedef union YYSTYPE {
  int number;
  char *string;
  Variant *variant;
  PropertyStruct *propertyref;
  void *paramlist;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 198 "script_bison.cpp"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 210 "script_bison.cpp"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  53
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   146

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  41
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  23
/* YYNRULES -- Number of rules. */
#define YYNRULES  67
/* YYNRULES -- Number of states. */
#define YYNSTATES  111

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   295

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    37,    40,
      43,    46,    51,    56,    59,    62,    65,    67,    70,    72,
      76,    80,    84,    86,    90,    94,    98,   102,   106,   110,
     112,   116,   120,   123,   125,   129,   133,   137,   141,   143,
     145,   147,   149,   153,   155,   159,   161,   163,   165,   171,
     178,   182,   188,   195,   197,   201,   205,   209
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      42,     0,    -1,    43,    -1,    42,    43,    -1,    44,    -1,
      45,    -1,    47,    -1,    46,    -1,    49,    -1,    50,    -1,
      51,    -1,    52,    -1,    53,    -1,    59,    -1,    63,    -1,
      37,    -1,     1,    -1,     3,    54,    -1,     4,    54,    -1,
       7,    54,    -1,     5,    54,    -1,     5,    38,    54,    39,
      -1,     6,    38,    54,    39,    -1,     8,    54,    -1,     9,
      54,    -1,    10,    18,    -1,    11,    -1,    12,    54,    -1,
      55,    -1,    54,    28,    55,    -1,    54,    27,    55,    -1,
      54,    29,    55,    -1,    56,    -1,    55,    31,    56,    -1,
      55,    32,    56,    -1,    55,    34,    56,    -1,    55,    33,
      56,    -1,    55,    36,    56,    -1,    55,    35,    56,    -1,
      57,    -1,    56,    19,    57,    -1,    56,    20,    57,    -1,
      30,    57,    -1,    58,    -1,    57,    21,    58,    -1,    57,
      22,    58,    -1,    57,    23,    58,    -1,    57,    24,    58,
      -1,    13,    -1,    14,    -1,    48,    -1,    60,    -1,    18,
      25,    18,    -1,    18,    -1,    38,    54,    39,    -1,    15,
      -1,    16,    -1,    17,    -1,    18,    25,    18,    38,    39,
      -1,    18,    25,    18,    38,    61,    39,    -1,    18,    25,
      18,    -1,    18,    25,    18,    38,    39,    -1,    18,    25,
      18,    38,    61,    39,    -1,    54,    -1,    61,    40,    54,
      -1,    18,    25,    18,    -1,    62,    26,    54,    -1,    18,
      26,    54,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    91,    91,    93,    97,    99,   101,   103,   105,   107,
     109,   111,   113,   115,   117,   119,   121,   127,   134,   144,
     155,   165,   173,   183,   193,   203,   210,   216,   223,   225,
     231,   237,   245,   247,   254,   261,   267,   273,   279,   287,
     289,   296,   302,   309,   311,   317,   329,   335,   343,   348,
     352,   354,   356,   365,   377,   382,   386,   390,   396,   402,
     410,   418,   424,   435,   441,   448,   457,   465
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tECHO", "tEXECHIDE", "tEXECWAIT", 
  "tEXECWAITCAPTURE", "tEXEC", "tLOAD", "tLOADPLUGIN", "tPAGE", "tQUIT", 
  "tDELAY", "tSTRING", "tNUMBER", "tTRUE", "tFALSE", "tNULL", "tIDENT", 
  "tPLUS", "tMINUS", "tMULTIPLY", "tDIVIDE", "tREMAINDER", "tPOWER", 
  "tDOT", "tASSIGN", "tAND", "tOR", "tXOR", "tNOT", "tEQUAL", "tNOTEQUAL", 
  "tLESS", "tGREATER", "tLESSEQUAL", "tGREATEREQUAL", "tCOMMENT", 
  "tLBRACKET", "tRBRACKET", "tCOMMA", "$accept", "statementlist", 
  "statement", "echo", "execute_hide", "execute", "execute_wait", 
  "execute_wait_ret", "load", "loadplugin", "page", "quit", "delay", 
  "expr", "compexpr", "arithexpr", "multexpr", "exprvalue", "methodcall", 
  "methodcallreturn", "parameterlist", "property", "assign", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    41,    42,    42,    43,    43,    43,    43,    43,    43,
      43,    43,    43,    43,    43,    43,    43,    44,    45,    46,
      47,    48,    48,    49,    50,    51,    52,    53,    54,    54,
      54,    54,    55,    55,    55,    55,    55,    55,    55,    56,
      56,    56,    56,    57,    57,    57,    57,    57,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,    59,    59,
      59,    60,    60,    61,    61,    62,    63,    63
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     4,     4,     2,     2,     2,     1,     2,     1,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     2,     1,     3,     3,     3,     3,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     5,     6,
       3,     5,     6,     1,     3,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    16,     0,     0,     0,     0,     0,     0,     0,    26,
       0,     0,    15,     0,     2,     4,     5,     7,     6,     8,
       9,    10,    11,    12,    13,     0,    14,     0,     0,    48,
      49,    55,    56,    57,    53,     0,     0,    50,    17,    28,
      32,    39,    43,    51,    18,    20,    19,    23,    24,    25,
      27,     0,     0,     1,     3,     0,     0,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    60,    67,    66,     0,
       0,    52,    54,    30,    29,    31,    33,    34,    36,    35,
      38,    37,    40,    41,    44,    45,    46,    47,     0,    21,
      22,     0,    58,    63,     0,    61,     0,    59,     0,    62,
      64
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,    13,    14,    15,    16,    17,    18,    37,    19,    20,
      21,    22,    23,   103,    39,    40,    41,    42,    24,    43,
     104,    25,    26
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -48
static const yysigned_char yypact[] =
{
      28,   -48,    82,    82,    82,    82,    82,    82,     1,   -48,
      82,    19,   -48,     6,   -48,   -48,   -48,   -48,   -48,   -48,
     -48,   -48,   -48,   -48,   -48,    15,   -48,    11,    48,   -48,
     -48,   -48,   -48,   -48,    79,   108,    82,   -48,    80,    96,
      47,    -1,   -48,   -48,    80,    80,    80,    80,    80,   -48,
      80,    87,    82,   -48,   -48,    82,    82,    82,    92,    -1,
      29,    82,    82,    82,    82,    82,    82,    82,    82,    82,
     108,   108,   108,   108,   108,   108,     4,    80,    80,    44,
      62,    73,   -48,    96,    96,    96,    47,    47,    47,    47,
      47,    47,    -1,    -1,   -48,   -48,   -48,   -48,    46,   -48,
     -48,    64,   -48,    80,    35,   -48,    53,   -48,    82,   -48,
      80
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -48,   -48,   105,   -48,   -48,   -48,   -48,   -48,   -48,   -48,
     -48,   -48,   -48,    -2,    54,    69,   -23,   -47,   -48,   -48,
      18,   -48,   -48
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -66
static const yysigned_char yytable[] =
{
      38,    44,    45,    46,    47,    48,    53,     1,    50,     2,
       3,     4,    59,     5,     6,     7,     8,     9,    10,    49,
      72,    73,    74,    75,    11,    94,    95,    96,    97,     1,
     -65,     2,     3,     4,    60,     5,     6,     7,     8,     9,
      10,    55,    98,    12,    51,    52,    11,    92,    93,    56,
      77,    27,    28,    78,    79,    80,    61,    62,    63,    29,
      30,    31,    32,    33,    34,    12,    70,    71,    82,    27,
      28,    61,    62,    63,   107,   108,    35,    29,    30,    31,
      32,    33,    34,    99,    36,   102,    57,    27,    28,    61,
      62,    63,   109,   108,    35,    29,    30,    31,    32,    33,
      34,   100,    36,   105,    58,    76,   110,    61,    62,    63,
      81,   101,    35,    27,    28,    83,    84,    85,    54,   106,
      36,    29,    30,    31,    32,    33,    34,    64,    65,    66,
      67,    68,    69,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,     0,    36
};

static const yysigned_char yycheck[] =
{
       2,     3,     4,     5,     6,     7,     0,     1,    10,     3,
       4,     5,    35,     7,     8,     9,    10,    11,    12,    18,
      21,    22,    23,    24,    18,    72,    73,    74,    75,     1,
      26,     3,     4,     5,    36,     7,     8,     9,    10,    11,
      12,    26,    38,    37,    25,    26,    18,    70,    71,    38,
      52,     5,     6,    55,    56,    57,    27,    28,    29,    13,
      14,    15,    16,    17,    18,    37,    19,    20,    39,     5,
       6,    27,    28,    29,    39,    40,    30,    13,    14,    15,
      16,    17,    18,    39,    38,    39,    38,     5,     6,    27,
      28,    29,    39,    40,    30,    13,    14,    15,    16,    17,
      18,    39,    38,    39,    25,    18,   108,    27,    28,    29,
      18,    38,    30,     5,     6,    61,    62,    63,    13,   101,
      38,    13,    14,    15,    16,    17,    18,    31,    32,    33,
      34,    35,    36,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    38
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,     4,     5,     7,     8,     9,    10,    11,
      12,    18,    37,    42,    43,    44,    45,    46,    47,    49,
      50,    51,    52,    53,    59,    62,    63,     5,     6,    13,
      14,    15,    16,    17,    18,    30,    38,    48,    54,    55,
      56,    57,    58,    60,    54,    54,    54,    54,    54,    18,
      54,    25,    26,     0,    43,    26,    38,    38,    25,    57,
      54,    27,    28,    29,    31,    32,    33,    34,    35,    36,
      19,    20,    21,    22,    23,    24,    18,    54,    54,    54,
      54,    18,    39,    55,    55,    55,    56,    56,    56,    56,
      56,    56,    57,    57,    58,    58,    58,    58,    38,    39,
      39,    38,    39,    54,    61,    39,    61,    39,    40,    39,
      54
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 16:
#line 121 "script_bison.ypp"
    {
      printScriptError(((ParserExecutionContext*)parm)->GetLexer(), "");
    ;}
    break;

  case 17:
#line 127 "script_bison.ypp"
    {
      cout << *yyvsp[0].variant << endl;
      delete yyvsp[0].variant;
    ;}
    break;

  case 18:
#line 134 "script_bison.ypp"
    {
      if(((ParserExecutionContext*)parm)->GetLexer()->IsTrusted())
        executeHide(*yyvsp[0].variant);
      else
        cerr << "exechide: permission denied - command blocked" << endl;
      delete yyvsp[0].variant;
    ;}
    break;

  case 19:
#line 144 "script_bison.ypp"
    {
      if(((ParserExecutionContext*)parm)->GetLexer()->IsTrusted()) {
        execute(yyvsp[0].variant->c_str(), true, false);
      }
      else
        cerr << "exec: permission denied - command blocked" << endl;
      delete yyvsp[0].variant;
    ;}
    break;

  case 20:
#line 155 "script_bison.ypp"
    {
      if(((ParserExecutionContext*)parm)->GetLexer()->IsTrusted())
        execute(yyvsp[0].variant->c_str(), false, false);
      else
        cerr << "execwait: permission denied - command blocked" << endl;
      delete yyvsp[0].variant;
    ;}
    break;

  case 21:
#line 165 "script_bison.ypp"
    {
      if(((ParserExecutionContext*)parm)->GetLexer()->IsTrusted())
        yyval.variant = newVariant(execute(yyvsp[-1].variant->c_str(), false, false));
      else
        cerr << "execwait: permission denied - command blocked" << endl;
      delete yyvsp[-1].variant;
    ;}
    break;

  case 22:
#line 173 "script_bison.ypp"
    {
      if(((ParserExecutionContext*)parm)->GetLexer()->IsTrusted())
        yyval.variant = newVariant(execute(yyvsp[-1].variant->c_str(), false, true));
      else
        cerr << "execwaitcapture: permission denied - command blocked" << endl;
      delete yyvsp[-1].variant;
    ;}
    break;

  case 23:
#line 183 "script_bison.ypp"
    {
      if(((ParserExecutionContext*)parm)->GetLexer()->IsTrusted())
        switchFileEvent(yyvsp[0].variant->c_str(), NULL);
      else
        cerr << "load: permission denied - command blocked" << endl;
      delete yyvsp[0].variant;
    ;}
    break;

  case 24:
#line 193 "script_bison.ypp"
    {
      if(((ParserExecutionContext*)parm)->GetLexer()->IsTrusted())
        plugin_manager.LoadPlugin(yyvsp[0].variant->c_str(), true);
      else
        cerr << "loadplugin: permission denied - command blocked" << endl;
      delete yyvsp[0].variant;
    ;}
    break;

  case 25:
#line 203 "script_bison.ypp"
    {
      switchPageEvent(yyvsp[0].string);
      free(yyvsp[0].string);
    ;}
    break;

  case 26:
#line 210 "script_bison.ypp"
    {
      SignalExit();
    ;}
    break;

  case 27:
#line 216 "script_bison.ypp"
    {
      delayms((int)*yyvsp[0].variant);
      delete yyvsp[0].variant;
    ;}
    break;

  case 29:
#line 225 "script_bison.ypp"
    {
      yyval.variant = newVariant((bool)*yyvsp[-2].variant || (bool)*yyvsp[0].variant);
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 30:
#line 231 "script_bison.ypp"
    {
      yyval.variant = newVariant((bool)*yyvsp[-2].variant && (bool)*yyvsp[0].variant);
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 31:
#line 237 "script_bison.ypp"
    {
      yyval.variant = newVariant((bool)((bool)*yyvsp[-2].variant ^ (bool)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 33:
#line 247 "script_bison.ypp"
    {
      // Comparison
      yyval.variant = newVariant(*yyvsp[-2].variant == *yyvsp[0].variant);
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 34:
#line 254 "script_bison.ypp"
    {
      // Comparison
      yyval.variant = newVariant(*yyvsp[-2].variant != *yyvsp[0].variant);
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 35:
#line 261 "script_bison.ypp"
    {
      yyval.variant = newVariant(((int)*yyvsp[-2].variant) > ((int)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 36:
#line 267 "script_bison.ypp"
    {
      yyval.variant = newVariant(((int)*yyvsp[-2].variant) < ((int)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 37:
#line 273 "script_bison.ypp"
    {
      yyval.variant = newVariant(((int)*yyvsp[-2].variant) >= ((int)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 38:
#line 279 "script_bison.ypp"
    {
      yyval.variant = newVariant(((int)*yyvsp[-2].variant) <= ((int)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 40:
#line 289 "script_bison.ypp"
    {
      // Concatenate strings (or add numerically, if both are numbers)
      yyval.variant = newVariant(*yyvsp[-2].variant + *yyvsp[0].variant);
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 41:
#line 296 "script_bison.ypp"
    {
      yyval.variant = newVariant(((int)*yyvsp[-2].variant) - ((int)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 42:
#line 302 "script_bison.ypp"
    {
      yyval.variant = newVariant(!((bool)*yyvsp[0].variant));
      delete yyvsp[0].variant;
    ;}
    break;

  case 44:
#line 311 "script_bison.ypp"
    {
      yyval.variant = newVariant(((int)*yyvsp[-2].variant) * ((int)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 45:
#line 317 "script_bison.ypp"
    {
      int divisor = ((int)*yyvsp[0].variant);
      if(divisor == 0) {
        cerr << "script error: division by zero" << endl;
        yyval.variant = newVariant(VARNULL);
      }
      else
        yyval.variant = newVariant(((int)*yyvsp[-2].variant) / divisor);
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 46:
#line 329 "script_bison.ypp"
    {
      yyval.variant = newVariant(((int)*yyvsp[-2].variant) % ((int)*yyvsp[0].variant));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 47:
#line 335 "script_bison.ypp"
    {
      yyval.variant = newVariant((int)pow((double)((int)*yyvsp[-2].variant), ((int)*yyvsp[0].variant)));
      delete yyvsp[-2].variant;
      delete yyvsp[0].variant;
    ;}
    break;

  case 48:
#line 343 "script_bison.ypp"
    {
      yyval.variant = newVariant(yyvsp[0].string);
      free(yyvsp[0].string);
    ;}
    break;

  case 49:
#line 348 "script_bison.ypp"
    {
      yyval.variant = newVariant(yyvsp[0].number);
    ;}
    break;

  case 52:
#line 356 "script_bison.ypp"
    {
      // FIXME need to check if $1 is a variable
//X      if($1->GetType() == VARTYPE_OBJREF)
      // Dereference the property value
      yyval.variant = newVariant(plugin_manager.GetPropertyValue(yyvsp[-2].string, yyvsp[0].string));
      free(yyvsp[-2].string);
      free(yyvsp[0].string);
    ;}
    break;

  case 53:
#line 365 "script_bison.ypp"
    {
      std::map<std::string,Variant>::iterator p;
      p = vartable.find(yyvsp[0].string);
      if(p == vartable.end()) {
        cerr << "script error: use of uninitialised variable '" << yyvsp[0].string << "'" << endl;
        yyval.variant = newVariant(VARNULL);
      }
      else
        yyval.variant = newVariant(p->second);
      free(yyvsp[0].string);
    ;}
    break;

  case 54:
#line 377 "script_bison.ypp"
    {
      // Bracket enclosure
      yyval.variant = yyvsp[-1].variant;
    ;}
    break;

  case 55:
#line 382 "script_bison.ypp"
    {
      yyval.variant = newVariant(true);
    ;}
    break;

  case 56:
#line 386 "script_bison.ypp"
    {
      yyval.variant = newVariant(false);
    ;}
    break;

  case 57:
#line 390 "script_bison.ypp"
    {
      yyval.variant = newVariant(VARNULL);
    ;}
    break;

  case 58:
#line 396 "script_bison.ypp"
    {
      callMethodArgs(yyvsp[-4].string, yyvsp[-2].string, NULL);
      free(yyvsp[-4].string);
      free(yyvsp[-2].string);
    ;}
    break;

  case 59:
#line 402 "script_bison.ypp"
    {
      vector<Variant> *args = ((vector<Variant> *)yyvsp[-1].paramlist);
      callMethodArgs(yyvsp[-5].string, yyvsp[-3].string, args);
      delete args;
      free(yyvsp[-5].string);
      free(yyvsp[-3].string);
    ;}
    break;

  case 60:
#line 410 "script_bison.ypp"
    {
      callMethod(yyvsp[-2].string, yyvsp[0].string, 0, NULL);
      free(yyvsp[-2].string);
      free(yyvsp[0].string);
    ;}
    break;

  case 61:
#line 418 "script_bison.ypp"
    {
      yyval.variant = newVariant(callMethodArgs(yyvsp[-4].string, yyvsp[-2].string, NULL));
      free(yyvsp[-4].string);
      free(yyvsp[-2].string);
    ;}
    break;

  case 62:
#line 424 "script_bison.ypp"
    {
      // tough call...
      vector<Variant> *args = ((vector<Variant> *)yyvsp[-1].paramlist);
      yyval.variant = newVariant(callMethodArgs(yyvsp[-5].string, yyvsp[-3].string, args));
      delete args;
      free(yyvsp[-5].string);
      free(yyvsp[-3].string);
    ;}
    break;

  case 63:
#line 435 "script_bison.ypp"
    {
      yyval.paramlist = new vector<Variant>;
      ((vector<Variant> *)yyval.paramlist)->push_back(*yyvsp[0].variant);
      delete yyvsp[0].variant;
    ;}
    break;

  case 64:
#line 441 "script_bison.ypp"
    {
      ((vector<Variant> *)yyval.paramlist)->push_back(*yyvsp[0].variant);
      delete yyvsp[0].variant;
    ;}
    break;

  case 65:
#line 448 "script_bison.ypp"
    {
      PropertyStruct *p = new PropertyStruct;
      p->object = yyvsp[-2].string;
      p->property = yyvsp[0].string;
      yyval.propertyref = p;
    ;}
    break;

  case 66:
#line 457 "script_bison.ypp"
    {
      plugin_manager.SetPropertyValue(yyvsp[-2].propertyref->object, yyvsp[-2].propertyref->property, *yyvsp[0].variant);
      free(yyvsp[-2].propertyref->object);
      free(yyvsp[-2].propertyref->property);
      delete yyvsp[-2].propertyref;
      delete yyvsp[0].variant;
    ;}
    break;

  case 67:
#line 465 "script_bison.ypp"
    {
      // tough assignment...
      if(checkName(yyvsp[-2].string)) {
        std::map<std::string,Variant>::iterator p;
        p = vartable.find(yyvsp[-2].string);
        if(p != vartable.end())
          vartable.erase(p);
        vartable.insert(make_pair(yyvsp[-2].string,*yyvsp[0].variant));
      }
      else {
        cerr << "script error: '" << yyvsp[-2].string << "' is not a valid variable name" << endl;
        delete yyvsp[0].variant;
      }
      free(yyvsp[-2].string);
    ;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1644 "script_bison.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 482 "script_bison.ypp"


Variant callMethodArgs(const char *object, const char *method, vector<Variant> *args) {
  if(args) {
    Variant argsarray[args->size()];
    for(unsigned int i=0; i<args->size(); i++)
      argsarray[i] = (*args)[i];
    return plugin_manager.CallMethod(object, method, args->size(), argsarray);
  }
  else
    return plugin_manager.CallMethod(object, method, 0, NULL);
}

void yyerror(char *message) {
  // We print out the line number using the built-in error directive (see above)
  cerr << message << endl;
}

int yylex(YYSTYPE *lvalp, void* parm) {
  int result;

  ((ParserExecutionContext*)parm)->GetLexer()->embedded_yylex(result, lvalp);
  return result;
}


