/***************************************************************************
        actionhandler.h  -  action handler for pages/system object
                             -------------------
    begin                : Fri Apr 16 2004
    copyright            : (C) 2004 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__ACTIONHANDLER_H
#define INCLUDED__ACTIONHANDLER_H

#include <string>
#include "actionobject.h"
#include "scriptbase.h"

class ActionHandler: public ActionObject {
  public:
    ActionHandler(ScriptBase *script, std::string actionname, bool system);
    virtual ~ActionHandler(void);
    virtual void Execute(void);
    std::string GetAction(void);
    bool IsSystem(void);
  private:
    ScriptBase *script;
    std::string actionname;
    bool system;
};

#endif
