/***************************************************************************
           externalmethodhandler.h  -  method handler for plugins
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__EXTERNALMETHODHANDLER_H
#define INCLUDED__EXTERNALMETHODHANDLER_H

#include "object.h"
#include "methodhandler.h"
#include "../plugintypes.h"

class ExternalMethodHandler: public MethodHandler {
  public:
    ExternalMethodHandler(const char *name, Object *owner, int numargs, methodfn methodfuncex);
    Variant Call(int numargs, Variant args[]);
  protected:
    methodfn methodfuncex;
};

#endif
