/***************************************************************************
                 functioneventhandler.cpp  -  event handler for plugins
                             -------------------
    begin                : Sun Oct 13 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cstdio>

#include "functioneventhandler.h"

using namespace std;

FunctionEventHandler::FunctionEventHandler(const char *name, Object *source, Object *sink, int (*eventfunction)(const char *))
: EventHandler(name, source, sink) {
  this->eventfunction = eventfunction;
  this->threaded = false;
}

int FunctionEventHandler::InternalFire(void) {
  return eventfunction(source->GetName());
}
