/***************************************************************************
                 functioneventhandler.h  -  event handler for plugins
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__FUNCTIONEVENTHANDLER_H
#define INCLUDED__FUNCTIONEVENTHANDLER_H

#include "eventhandler.h"
 
class FunctionEventHandler: public EventHandler {
  public:
    FunctionEventHandler(const char *name, Object *source, Object *sink, int (*eventfunction)(const char *));
  protected:
    virtual int InternalFire(void);
  private:
    int (*eventfunction)(const char *);
};

#endif
