/***************************************************************************
                 methodhandler.cpp - method handling base object
                             -------------------
    begin                : Sat Nov 16 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstring>
#include <cstdlib>

#include "methodhandler.h"

using namespace std;

MethodHandler::MethodHandler(const char *name, Object *owner, int numargs) {
  this->name = strdup(name);
  this->numargs = numargs;
  this->owner = owner;
}

MethodHandler::~MethodHandler(void) {
  free(name);
}

const char *MethodHandler::GetName(void) {
  return name;
}

Object *MethodHandler::GetOwner(void) {
  return owner;
}
