/***************************************************************************
    resolverbase.h  -  simple abstract class for name-to-object resolver
                             -------------------
    begin                : Thu Nov 20 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__RESOLVERBASE_H
#define INCLUDED__RESOLVERBASE_H

#include "dynamicobject.h"

enum {
  RSCOPE_TEMP,
  RSCOPE_PAGE,
  RSCOPE_GLOBAL
};

class ResolverBase {
  public:
    virtual DynamicObject *Resolve(const char *name, int scope) = 0;
};

#endif
