/***************************************************************************
                          resource.cpp  -  resource classes
                             -------------------
    begin                : Mon Oct 6 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cstdlib>
#include <cstring>

#include "resource.h"

using namespace std;

/* Base resource */
   
Resource::Resource(const string filename) {
  this->filename = filename;
  this->reshandle = NULL;
}

Resource::~Resource(void) {
  //
}

const string Resource::GetFilename(void) {
  return filename;
}

void *Resource::GetHandle(void) {
  return reshandle;
}

/* Font resource */

FontResource::FontResource(string filename, int fontsize)
: Resource(filename) {
  this->fontsize = fontsize;
}

int FontResource::GetFontSize(void) {
  return fontsize;
}

