/***************************************************************************
               gui_resource.h  -  SDL_gui-based resource classes
                             -------------------
    begin                : Wed Oct 8 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__GUI_RESOURCE_H
#define INCLUDED__GUI_RESOURCE_H

#include <string>

#include "../../basewidgets/resource.h"

class SDL_guiImageResource: public ImageResource {
  public:
    SDL_guiImageResource(std::string filename);
    virtual void *Load(void);
    virtual void Unload(void);
};

class SDL_guiFontResource: public FontResource {
  public:
    SDL_guiFontResource(std::string filename, int fontsize);
    virtual void *Load(void);
    virtual void Unload(void);
};

#endif
