/***************************************************************************
                          page.h  -  eboxy page (not really a widget)
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__PAGE_H
#define INCLUDED__PAGE_H

#include "../../basewidgets/pagebase.h"
#include "widget.h"

class ebPage: public ebWidget, public PageBase {
  public:
    ebPage(const char *name, int x, int y, int w, int h);
    virtual ~ebPage(void);
    virtual GUI_Widget *Instantiate(void);
    virtual void Uninstantiate(void);
    void SetBackground(ImageResource *image);
    void AddWidget(WidgetBase *widget);
    void RemoveWidget(WidgetBase *widget);
    void UpdateFocus(void);
    void InvalidateRect(SDL_Rect a);
    void SetVisible(bool visible);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
  private:
};

#endif
