/***************************************************************************
                          picturewidget.h  -  eboxy static image widget
                             -------------------
    begin                : Mon May 12 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__PICTUREWIDGET_H
#define INCLUDED__PICTUREWIDGET_H
 
#include "../../basewidgets/picturewidgetbase.h"
#include "widget.h"
 
class PictureWidget: public ebWidget, public PictureWidgetBase {
  public:
    PictureWidget(const char *name, int x, int y, ImageResource *image);
    GUI_Widget *Instantiate(void);
    void SetImage(ImageResource *image);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
};

#endif
