/***************************************************************************
                      timer.h - object wrapper for SDL timer
                             -------------------
    begin                : Wed May 14 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TIMER_H
#define INCLUDED__TIMER_H

#include "../../basewidgets/timerbase.h"

class TimerObject: public TimerObjectBase {
  public:
    TimerObject(const char *name, int interval, bool autostart);
    virtual ~TimerObject(void);
    void SetEnabled(bool enable);
  private:
    SDL_TimerID timer_id;
};

#endif
